package cn.com.qmth.examcloud.core.basic.service.cache;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import cn.com.qmth.examcloud.core.basic.dao.StudentRepo;
import cn.com.qmth.examcloud.core.basic.dao.entity.StudentEntity;
import cn.com.qmth.examcloud.support.cache.bean.StudentCacheBean;
import cn.com.qmth.examcloud.web.cache.RandomObjectRedisCache;
import cn.com.qmth.examcloud.web.helpers.GlobalHelper;

@Service
public class StudentCache extends RandomObjectRedisCache<StudentCacheBean> {

	@Autowired
	StudentRepo studentRepo;

	@Override
	public StudentCacheBean loadFromResource(Object... keys) {
		Long studentId = (Long) keys[0];

		StudentEntity s = GlobalHelper.getPresentEntity(studentRepo, studentId,
				StudentEntity.class);

		StudentCacheBean b = new StudentCacheBean();
		b.setId(s.getId());
		b.setEnable(s.getEnable());
		b.setIdentityNumber(s.getIdentityNumber());
		b.setName(s.getName());
		b.setOrgId(s.getOrgId());
		b.setPhoneNumber(s.getPhoneNumber());
		b.setPhotoPath(s.getPhotoPath());
		b.setRemark(s.getRemark());
		b.setRootOrgId(s.getRootOrgId());
		b.setSecurityPhone(s.getSecurityPhone());

		return b;
	}

	@Override
	protected String getKeyPrefix() {
		return "B_STUDENT:";
	}

	@Override
	protected int getTimeout() {
		// 5分钟
		return 60 * 5;
	}

}
